import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;
import java.io.*;

class AdminListener implements ActionListener {

private MLFrame frame;
private Liga liga;

public AdminListener (MLFrame f) {
frame=f;
}

public void actionPerformed (ActionEvent e){
PanelUser paneluser = new PanelUser();
frame.setContentPane(paneluser);
frame.validate();

}

class PanelUser extends JPanel {
	private final String User = "user";
	private final String Pass = "1234";
	private JLabel l1 = new JLabel("User");
	private JTextField tf1 = new JTextField(10);
	private JLabel l2 = new JLabel("Pass");
	private JPasswordField tf2 = new JPasswordField(10);
	private JButton ok= new JButton("Iniciar Sesion");
	private ValidarUsuario validarusuario = new ValidarUsuario(this);
	private Image imagen;
	
	public PanelUser (){
		JPanel p1 = new JPanel();
		p1.add(l1);
		p1.add(tf1);
		p1.add(l2);
		p1.add(tf2);
		p1.add(ok);
		this.add(p1);
		this.setImagen("mleague.png");
		ok.addActionListener(validarusuario);
	}
	
	public void setImagen(String nombreImagen) {
        if (nombreImagen != null) {
			imagen = new ImageIcon(getClass().getResource(nombreImagen)).getImage();
			} else {
					imagen = null;
					}
				repaint();
	}
	
	 public void paint(Graphics g) {
			if (imagen != null) {
			g.drawImage(imagen, 0, 0, getWidth(), getHeight(),this);
			setOpaque(false);
		} else {
				setOpaque(true);
				}
			super.paint(g);
	}
	
	
	
	
	public boolean usuarioValido (){
		if(tf1.getText().equals(User) && tf2.getText().equals(Pass))
			return true;
		else
			return false;
	}

}


class ValidarUsuario implements ActionListener{
	private PanelUser paneluser;
	private PanelAdmin paneladmin = new PanelAdmin();
	
	
	public ValidarUsuario(PanelUser pu){
		paneluser=pu;
	}
	public void actionPerformed (ActionEvent e){
		if (paneluser.usuarioValido()){
		frame.setContentPane(paneladmin);
		frame.repaint();
		frame.validate();
		}
		else
			JOptionPane.showMessageDialog(frame, "Usuario o Pass Incorrecta.");
	}
}



class PanelAdmin extends JPanel implements ActionListener{
	private JButton Actualizar = new JButton("Actualizar");
	private JButton CrearNuevaLiga = new JButton("Crear Nueva Liga");
	private PanelNuevaLiga panelnuevaliga = new PanelNuevaLiga();
	private PanelActualizar panelactualizar = new PanelActualizar(frame);
	private Image imagen;
	
	public PanelAdmin (){
		add(Actualizar);
		add(CrearNuevaLiga);
		this.setImagen("mleague.png");
		Actualizar.addActionListener(panelactualizar);
		CrearNuevaLiga.addActionListener(this);
	}
	
	public void setImagen(String nombreImagen) {
        if (nombreImagen != null) {
			imagen = new ImageIcon(getClass().getResource(nombreImagen)).getImage();
			} else {
					imagen = null;
					}
				repaint();
	}
	
	 public void paint(Graphics g) {
			if (imagen != null) {
			g.drawImage(imagen, 0, 0, getWidth(), getHeight(),this);
			setOpaque(false);
		} else {
				setOpaque(true);
				}
			super.paint(g);
	}
	
	
	
	public void actionPerformed (ActionEvent e){
		if(e.getActionCommand().equals("Crear Nueva Liga")){
		frame.setContentPane(panelnuevaliga);
		frame.validate();
		}
		
   }
}

class PanelNuevaLiga extends JPanel implements ActionListener{
	
	private JLabel l1 = new JLabel("Ingrese Nombre de la Liga");
	private JTextField tf1 = new JTextField(20);
	private JLabel l2 = new JLabel("Ingrese Numero de Equipos");
	private JTextField tf2 = new JTextField(4);
	private JLabel l3 = new JLabel("Ingrese Numero Jugadores por Equipo");
	private JTextField tf3 = new JTextField(4);
	private JButton Siguiente = new JButton("Siguiente");
	
	public PanelNuevaLiga(){
	JPanel p1 = new JPanel();
    p1.add(l1);
    p1.add(tf1);
    JPanel p2 = new JPanel();
    p2.add(l2);
    p2.add(tf2);
    JPanel p3 = new JPanel();
    p3.add(l3);
    p3.add(tf3);
    JPanel p4 = new JPanel();
    p4.add(Siguiente);
    setLayout(new GridLayout(8,1));
    this.add(p1);
    this.add(p2);
    this.add(p3);
    this.add(p4);
    Siguiente.addActionListener(this);
	}
	public void actionPerformed (ActionEvent e){
		liga = new Liga();
		liga.setNombreLiga(tf1.getText());
		liga.setNumeroEquipos(Integer.parseInt(tf2.getText()));
		liga.setJugadoresxEquipo(Integer.parseInt(tf3.getText()));
		
		  try{
			  // Create file 
			  File dirliga = new File("liga");
			  dirliga.mkdir();
			  FileWriter fstream = new FileWriter("liga"+"/liga.txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  out.write(liga.getNombreLiga()+"\r\n");
			  out.write(liga.getNumeroEquipos()+"\r\n");
			  out.write(liga.getJugadoresxEquipo()+" ");
			  //Close the output stream
			  out.close();
			  }catch (Exception er){//Catch exception if any
			  System.err.println("Error: " + er.getMessage());
			  }
			  		
		frame.setLiga(liga);
		frame.setContentPane(new PanelEquipos());
		frame.repaint();
		frame.validate();
	}
		
}

class PanelEquipos extends JPanel implements ActionListener{
   private JLabel msj1 = new JLabel("Ingrese Nombre de Equipos Participantes");
   private JTextField[] nombresequipos = {new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20)};
   private JButton Siguiente = new JButton("Siguiente");
   
   public PanelEquipos (){
	   this.setLayout(new GridLayout(liga.getNumeroEquipos()+3,2));
	   add(msj1);
	   add(new JLabel(" ")); //Espacio vacio
	   for(int i=1 ; i <= liga.getNumeroEquipos() ; i++){
		   JLabel num = new JLabel(" "+i);
		   num.setHorizontalAlignment(JLabel.RIGHT);
		   add(num);
		   add(nombresequipos[i]);
	   }
	   add(new JLabel(" ")); //Espacio vacio
	   add(Siguiente);
	   Siguiente.addActionListener(this);
   }
   
	   public void actionPerformed (ActionEvent e){
		   for(int i=1 ; i <= liga.getNumeroEquipos() ; i++){
			  Equipo equipo= new Equipo(nombresequipos[i].getText());
			  liga.addEquipo(equipo);
			  
			  try{
				  // Create file 
				  File direquipo = new File("liga/"+equipo.getNombreEquipo());
				  direquipo.mkdirs();
				  FileWriter fstream = new FileWriter("liga"+"/"+equipo.getNombreEquipo()+"/"+equipo.getNombreEquipo()+".txt");
				  BufferedWriter out = new BufferedWriter(fstream);
				  out.write(equipo.getNombreEquipo()+"\r\n");
				  out.write("0 \r\n");
				  out.write("0 \r\n");
				  out.write("0 \r\n");
				  out.write("0 \r\n");
				  //Close the output stream
				  out.close();
				  }catch (Exception er){//Catch exception if any
				  System.err.println("Error: " + er.getMessage());
				  }
			  
		   }
		   
		   try{
				  // Create file 
				  File dirliga = new File("liga");
				  dirliga.mkdir();
				  FileWriter fstream = new FileWriter("liga"+"/tabla.txt");
				  BufferedWriter out = new BufferedWriter(fstream);
				  Vector <Equipo> teams=liga.getEquipos();
					for (Equipo t : teams)
						out.write(t.getNombreEquipo()+" "+t.getPartidosJugados()+" "+t.getGF()+" "+t.getGC()+" "+t.getPuntos()+"\r\n");
				    
				  //Close the output stream
				  out.close();
				  }catch (Exception er){//Catch exception if any
				  System.err.println("Error: " + er.getMessage());
				  }
			  

		   		   
		   frame.setContentPane(new PanelJugadores(liga.getEquipos().get(0)));
		   frame.repaint();	
		   frame.validate();
	   }
	   
}

class PanelJugadores extends JPanel implements ActionListener{
	private JLabel msj1 = new JLabel("Ingrese Nombre de Jugadores de ");
	private JTextField[] nombrejugadores = {new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20),new JTextField(20)};
	private JButton Siguiente = new JButton("Siguiente");
	private Equipo team;
	private int index;
	
	public PanelJugadores (Equipo t){
		 team=t;
		 this.setLayout(new GridLayout(liga.getJugadoresxEquipo()+3,2));
		   msj1.setHorizontalAlignment(JLabel.RIGHT);
		   add(msj1);
		   add(new JLabel(team.getNombreEquipo())); //Espacio vacio
		   for(int i=1 ; i <= liga.getJugadoresxEquipo() ; i++){
			   JLabel num = new JLabel(" "+i);
			   num.setHorizontalAlignment(JLabel.RIGHT);
			   add(num);
			   add(nombrejugadores[i]);
		   }
		   add(new JLabel(" ")); //Espacio vacio
		   add(Siguiente);
		   Siguiente.addActionListener(this);
	}
	public void actionPerformed (ActionEvent e){
		   index=liga.getEquipos().indexOf(team);
		   
		   if(index<=(liga.getNumeroEquipos())-1){
			
			for(int i=1 ; i<=liga.getJugadoresxEquipo() ; i++){   
			Jugador player = new Jugador(nombrejugadores[i].getText());
			team.addJugador(player);
			
			try{
				  // Create file 
				  File dirjugador = new File("liga"+"/"+team.getNombreEquipo()+"/Jugadores");
				  dirjugador.mkdirs();
				  FileWriter fstream = new FileWriter("liga"+"/"+team.getNombreEquipo()+"/Jugadores"+"/"+player.getNombreJugador()+".txt");
				  BufferedWriter out = new BufferedWriter(fstream);
				  out.write(player.getNombreJugador());
				  //Close the output stream
				  out.close();
				  }catch (Exception er){//Catch exception if any
				  System.err.println("Error: " + er.getMessage());
				  }
			
			}
			if (index<liga.getNumeroEquipos()-1){
				frame.setContentPane(new PanelJugadores(liga.getEquipos().get(index+1)));   
				frame.validate();
			}
			  else{
				  Fixture f=new Fixture(liga.getNumeroEquipos());
				  liga.setFixture(f.getFixture());
				  
				  try{
					  // Create file 
					  File dirliga = new File("liga");
					  dirliga.mkdir();
					  FileWriter fstream = new FileWriter("liga"+"/fixture.txt");
					  BufferedWriter out = new BufferedWriter(fstream);
					    for (int i = 0; i < f.getFixture().length; i++) {
					    	for (int j = 0 ; j<liga.getNumeroEquipos()/2 ; j++){
					        out.write(f.getFixture()[i][j]+" ");
					        out.newLine();
					    	}
					    	out.write("0");
					    	out.newLine();
					    }
					  //Close the output stream
					  out.close();
					  }catch (Exception er){//Catch exception if any
					  System.err.println("Error: " + er.getMessage());
					  }
				  
				  //generar directorio de partidos
				  
					int numfechas=liga.getNumeroEquipos()-1;
					int numequipos=liga.getNumeroEquipos();
					Vector <Equipo> teams = liga.getEquipos();
					FileReader ff;
					
					try {
						ff = new FileReader("liga/fixture.txt");
						Scanner sff = new Scanner(ff);
						int FechaActual=1;
						int numPartido=1;
						while(sff.hasNextInt()){
							int e1=sff.nextInt();
							if(e1==0)
								FechaActual++;
							else{
								int e2=sff.nextInt();
								Partido match = new Partido(false,FechaActual,e1,0,e2,0);
								liga.addPartido(match);


								try{
									  // Create file 
									  File dirjugador = new File("liga"+"/Partidos");
									  dirjugador.mkdirs();
									  FileWriter fstream = new FileWriter("liga"+"/Partidos"+"/"+numPartido+".txt");
									  BufferedWriter out = new BufferedWriter(fstream);
									  out.write(false+"\r\n");
									  out.write(FechaActual+"\r\n");
									  out.write(e1+"\r\n");
									  out.write("0\r\n");
									  out.write(e2+"\r\n");
									  out.write("0\r\n");
									  //Close the output stream
									  out.close();
									  }catch (Exception er){//Catch exception if any
									  System.err.println("Error: " + er.getMessage());
									  }
											
								numPartido++;
							}
						}
					} catch (FileNotFoundException e1) {
						e1.printStackTrace();
					}
						  
					frame.setContentPane(new PanelPrincipal(frame));
					frame.repaint();
					frame.validate();   
				   }
			
		   }
			
		  		   
	}
	
	
}
  
}





