import java.io.File;
import java.util.*;
/**
 * @
 * @author Mario Castro Cristobal Rodriguez
 * 
 */
public class Equipo {

private String NombreEquipo;
private Vector<Jugador> Jugadores = new Vector<Jugador>(20);
private int Puntos;
private int PartidosJugados;
private int GolesFavor;
private int GolesContra;

/**
 * Constructor para crear un nuevo Equipo
 * @param n Nombre del Equipo
 */
public Equipo (String n){
PartidosJugados=0;
Puntos=0;
GolesFavor=0;
GolesContra=0;
NombreEquipo=n;
Jugadores = new Vector<Jugador>();
}

/** 
 * Se elige el nombre del Equipo
 * 
 * @param n Nombre del Equipo
 */
public void setNombreEquipo( String n){
NombreEquipo = n;
}
/**
 * Se determina la cantidad de partidos jugados por el equipo
 * @param p Cantidad de Partidos Jugados
 */
public void setPartidosJugados (int p){
PartidosJugados=p;
}
/**
 * Se determina la cantidad de puntos del Equipo
 * @param p Cantidad de Puntos
 */
public void setPuntos (int p){
Puntos=p;
}
/**
 * Se obtienen los goles convertidos por el Equipo
 * @return Goles convertidos
 */
public int getGF (){
return GolesFavor;
}
/**
 * Se obtienen los goles que le han convertido al Equipo
 * @return Goles en Contra
 */
public int getGC (){
return GolesContra;
}
/**
 * Se obtiene la cantidad de partidos Jugados por el Equipo
 * @return Partidos Jugados
 */
public int getPartidosJugados (){
return PartidosJugados;
}
/**
 * Se obtiene la cantidad de Puntos del Equipo
 * @return Puntos del Equipo
 */
public int getPuntos (){
return Puntos;
}
/**
 * Se determina la cantidad de Goles a favor del Equipo
 * @param gf Goles a Favor
 */
public void setGF (int gf){
GolesFavor=gf;
}
/**
 * Se determina la cantidad de Goles en contra del Equipo
 * @param gf Goles en contra
 */
public void setGC (int gf){
GolesContra=gf;
}
/**
 * Se obtiene el nombre del Equipo
 * @return Nombre del Equipo
 */
public String getNombreEquipo(){
return NombreEquipo;
}
/**
 * Se agregan puntos al equipo
 * @param p Cantidad de puntos a agregar
 */
public void addPuntos (int p){
Puntos=Puntos+p;
}
/**
 * Se agrega un partido jugado al Equipo
 */
public void addPartidoJugado(){
PartidosJugados=PartidosJugados+1;
}
/**
 * Se agregan goles a favor y goles en contra al Equipo
 * @param f Goles a favor que se agregan
 * @param c Goles en contra que se agregan
 */
public void ActualizarGoles(int f,int c){
GolesFavor=GolesFavor+f;
GolesContra=GolesContra+c;
}
/**
 * Se agrega un jugador a la lista de jugadores del equipo
 * @param j Nuevo Jugador
 */
public void addJugador( Jugador j){
Jugadores.add(j);
}
/**
 * Se obtiene un vector que contiene el listado de jugadores del Equipo
 * @return Lista de Jugadores
 */
public Vector<Jugador> getJugadores(){
	return Jugadores;
}

}



