import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.Scanner;
import java.util.Vector;

import javax.swing.*;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;


public class PanelActualizar extends JPanel implements ActionListener{

	private MLFrame frame;
	private Liga liga;
	private int NUMfechas;
	private Tabla posiciones;
	private Image imagen;
	
	public PanelActualizar (MLFrame f){
		frame=f;
		this.setImagen("mleague.png");
	}
	public void setImagen(String nombreImagen) {
        if (nombreImagen != null) {
			imagen = new ImageIcon(getClass().getResource(nombreImagen)).getImage();
			} else {
					imagen = null;
					}
				repaint();
	}
	
	 public void paint(Graphics g) {
			if (imagen != null) {
			g.drawImage(imagen, 0, 0, getWidth(), getHeight(),this);
			setOpaque(false);
		} else {
				setOpaque(true);
				}
			super.paint(g);
	}
	
	public void actionPerformed(ActionEvent e) {
		liga = new Liga();
		
		
		try {
			//Carga Liga
			FileReader fr = new FileReader("liga"+"/liga.txt");
			Scanner sr = new Scanner(fr); 
			liga.setNombreLiga(sr.next());
			liga.setNumeroEquipos(sr.nextInt());
			liga.setJugadoresxEquipo(sr.nextInt());
			//Carga Equipo
			File df = new File ("liga");
			String [] dir = df.list();
			for(int i=0 ; i<dir.length ; i++){
				if(!(dir[i].equals("tabla.txt"))  && !(dir[i].equals("fixture.txt")) && !(dir[i].equals("liga.txt")) && !(dir[i].equals("Partidos"))){
					FileReader tf = new FileReader("liga/"+dir[i]+"/"+dir[i]+".txt");
					Scanner stf = new Scanner(tf);
					Equipo team = new Equipo(stf.next()); 
					team.setPartidosJugados(stf.nextInt());
					team.setPuntos(stf.nextInt());
					team.setGF(stf.nextInt());
					team.setGC(stf.nextInt());
					liga.addEquipo(team);
				}
				
			}

			
			
			int numfechas=liga.getNumeroEquipos()-1;
			NUMfechas=numfechas;
			int numequipos=liga.getNumeroEquipos();
			int numpartidos=numfechas*(numequipos/2);
			Vector <Equipo> teams = liga.getEquipos();
			
		    DefaultTableModel model = new DefaultTableModel(null, new String [] {"nroPartido","Fecha","Jugado","Equipo","Goles","Equipo","Goles"}) {
		    	public Class getColumnClass(int c) {
                  switch (c) {
                  	case 0: return Integer.class;
                  	case 1: return Integer.class;
                    case 2: return Boolean.class;
                    case 4: return Integer.class;
                    case 6: return Integer.class;
                    default: return String.class;
                  }   
                }
		    };

                JTable table = new JTable(model);
                
                for(int i=0 ; i<numpartidos ; i++){
    				FileReader tf = new FileReader("liga/Partidos/"+(i+1)+".txt");
    				Scanner stf = new Scanner(tf);
    				boolean jug=stf.nextBoolean();
    				int fec=stf.nextInt();
    				int e1=stf.nextInt()-1;
    				int ge1=stf.nextInt();
    				int e2=stf.nextInt()-1;
    				int ge2=stf.nextInt();
    				
    				if(jug)
    				model.addRow(new Object [] {(i+1),fec,false,teams.get(e1).getNombreEquipo(),ge1,teams.get(e2).getNombreEquipo(),ge2});
    				else
    					model.addRow(new Object [] {(i+1),fec,false,teams.get(e1).getNombreEquipo(),null ,teams.get(e2).getNombreEquipo(),null });
    				liga.addPartido(new Partido(jug,fec,e1,ge1,e2,ge2));
    			}

			JButton Guardar = new JButton("Guardar Cambios");
			JButton Home = new JButton("Home");
			IngresarResultados ir = new IngresarResultados(table,frame);
			Guardar.addActionListener(ir);
			Home.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
					frame.setContentPane(new PanelPrincipal(frame));
					frame.repaint();
					frame.validate();
					
				}
			});
			add(table);
			add(Guardar);
			add(Home);
			frame.setContentPane(this);
			frame.repaint();
			frame.validate();
						
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		}
		
	}
	
class IngresarResultados implements ActionListener {

private JTable table;
private Vector<Equipo> teams = liga.getEquipos();
private MLFrame frame;
private Image imagen;

public IngresarResultados(JTable t, MLFrame f){
	table=t;
	frame=f;
	
	
}

	public void actionPerformed(ActionEvent e) {
		for(int i=0 ; i<table.getRowCount() ; i++){
			if((table.getValueAt(i, 2)) instanceof Boolean){
				boolean jug=((Boolean)table.getValueAt(i, 2)).booleanValue();
				if(jug) {
					int nroPartido = ((int) table.getValueAt(i, 0))-1;
					int ge1 = (int) table.getValueAt(i, 4);
					int ge2 = (int) table.getValueAt(i, 6);
					int e1 = liga.getPartidos().get(nroPartido).getEquipo1();
					int e2 = liga.getPartidos().get(nroPartido).getEquipo2();
					int fecha = (int) table.getValueAt(i, 1);
					liga.getEquipos().get(e1).ActualizarGoles(ge1, ge2);
					liga.getEquipos().get(e2).ActualizarGoles(ge2, ge1);
					liga.getEquipos().get(e1).addPartidoJugado();
					liga.getEquipos().get(e2).addPartidoJugado();
					
					if(ge1>ge2)
						liga.getEquipos().get(e1).addPuntos(3);
					if(ge2>ge1)
						liga.getEquipos().get(e2).addPuntos(3);
					if(ge1==ge2){
						liga.getEquipos().get(e1).addPuntos(1);
						liga.getEquipos().get(e2).addPuntos(1);
					}
					
					//actualiza Partidos

					try{
						
						File yourFile = new File("liga"+"/Partidos"+"/"+(nroPartido+1)+".txt");
						yourFile.delete();
						  // Create file 
						  File dirjugador = new File("liga"+"/Partidos");
						  dirjugador.mkdirs();
						  FileWriter fstream = new FileWriter("liga"+"/Partidos"+"/"+(nroPartido+1)+".txt");
						  BufferedWriter out = new BufferedWriter(fstream);
						  out.write(jug+"\r\n");
						  out.write(fecha+"\r\n");
						  out.write((e1+1)+"\r\n");
						  out.write(ge1+"\r\n");
						  out.write((e2+1)+"\r\n");
						  out.write(ge2+"\r\n");

						  //Close the output stream
						  out.close();
						  }catch (Exception er){//Catch exception if any
						  System.err.println("Error: " + er.getMessage());
						  }
					  
					//actualiza Equipo1
					
					try{
						
						File yourFile = new File("liga/"+liga.getEquipos().get(e1).getNombreEquipo()+"/"+liga.getEquipos().get(e1).getNombreEquipo()+".txt");
						yourFile.delete();
		
						  // Create file 
						  FileWriter fstream = new FileWriter("liga/"+liga.getEquipos().get(e1).getNombreEquipo()+"/"+liga.getEquipos().get(e1).getNombreEquipo()+".txt");
						  BufferedWriter out = new BufferedWriter(fstream);
						  out.write(liga.getEquipos().get(e1).getNombreEquipo()+"\r\n");
						  out.write(liga.getEquipos().get(e1).getPartidosJugados()+"\r\n");
						  out.write(liga.getEquipos().get(e1).getPuntos()+"\r\n");
						  out.write(liga.getEquipos().get(e1).getGF()+"\r\n");
						  out.write(liga.getEquipos().get(e1).getGC()+"\r\n");
							
						  //Close the output stream
						  out.close(); 
						  }catch (Exception er){//Catch exception if any
						  System.err.println("Error: " + er.getMessage());
						  }
					
					//actualiza Equipo2
					
					try{
						
						File yourFile = new File("liga/"+liga.getEquipos().get(e2).getNombreEquipo()+"/"+liga.getEquipos().get(e2).getNombreEquipo()+".txt");
						yourFile.delete();
						
						  // Create file 
						  FileWriter fstream = new FileWriter("liga/"+liga.getEquipos().get(e2).getNombreEquipo()+"/"+liga.getEquipos().get(e2).getNombreEquipo()+".txt");
						  BufferedWriter out = new BufferedWriter(fstream);
						  out.write(liga.getEquipos().get(e2).getNombreEquipo()+"\r\n");
						  out.write(liga.getEquipos().get(e2).getPartidosJugados()+"\r\n");
						  out.write(liga.getEquipos().get(e2).getPuntos()+"\r\n");
						  out.write(liga.getEquipos().get(e2).getGF()+"\r\n");
						  out.write(liga.getEquipos().get(e2).getGC()+"\r\n");

						  //Close the output stream
						  out.close(); 
						  }catch (Exception er){//Catch exception if any
						  System.err.println("Error: " + er.getMessage());
						  }					
					
							
				}
					

			}
				
		}
		posiciones = new Tabla(liga);
		posiciones.actualizarTabla();
		frame.setContentPane(new PanelPrincipal(frame));
		frame.repaint();
		frame.validate();
		
	}
	
}




}
